"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useStyles = void 0;
const styles_1 = require("@material-ui/core/styles");
const theme_1 = require("../../theme");
exports.useStyles = (0, styles_1.makeStyles)({
    drawerContainer: {
        cursor: "pointer",
        width: 400,
        display: "flex",
        flexDirection: "column",
        justifyContent: "space-between",
        height: "100%",
        overflowX: "hidden",
        "& .MuiTextField-root": {
            width: "100%",
        },
        "& .MuiFilledInput-root": {
            borderRadius: 0,
        },
        "& .MuiSelect-outlined.MuiSelect-outlined": {
            padding: 12,
        },
    },
    header: {
        padding: "8px 40px",
        cursor: "auto",
    },
    body: {
        cursor: "auto",
        padding: "20px 40px",
    },
    footer: {
        display: "flex",
        justifyContent: "flex-end",
        padding: "20px 40px",
    },
    headerInfo: {
        color: "#9A9A9A",
        marginLeft: 10,
    },
    headerIcon: {
        fontSize: 24,
        color: "#9A9A9A",
        cursor: "pointer",
    },
    filterChipItem: {
        margin: 4,
        border: `1px solid ${theme_1.colors.GRAY200}`,
        backgroundColor: theme_1.colors.WHITE,
    },
    checkItem: {
        marginTop: 16,
        opacity: 0.9,
    },
    filterChipItemSelected: {
        backgroundColor: theme_1.colors.GRAY200,
    },
    widgetWrapper: { marginBottom: 24 },
    widgetLabel: {
        marginBottom: 8,
    },
    submitButton: {
        marginLeft: 16,
    },
    cancelButton: {},
    inputAdornment: {
        margin: "0 !important",
    },
    appliedFilterContainer: {
        marginTop: 8,
        marginBottom: 8,
        display: "flex",
        flexWrap: "wrap",
        listStyle: "none",
        padding: 4,
    },
    dateLabel: {
        width: 48,
    },
    dateWrapper: {
        display: "flex",
        alignItems: "center",
        marginBottom: 16,
    },
    textFieldWrapper: {
        margin: 0,
        "& input": {
            fontSize: theme_1.EFontSize.BODY2,
            padding: 12,
            backgroundColor: theme_1.colors.GRAY100,
        },
        "& .MuiInput-underline:after": {
            display: "none",
        },
        "& .MuiInput-underline:before": {
            display: "none",
        },
    },
    selectWrapper: {
        border: "none",
    },
});
//# sourceMappingURL=GovernanceSideFilter.style.js.map