"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GovernanceWidgetHeader = void 0;
const core_1 = require("@material-ui/core");
const react_1 = __importDefault(require("react"));
const GovernanceWidgetHeader_style_1 = require("../../components/GovernanceWidgetHeader/GovernanceWidgetHeader.style");
const components_1 = require("../../components");
const ArrowBack_1 = __importDefault(require("@material-ui/icons/ArrowBack"));
const GovernanceWidgetHeader = ({ navigationLink, label, description, rightContent, headerActions = [], }) => {
    const classes = (0, GovernanceWidgetHeader_style_1.useStyles)();
    return (react_1.default.createElement(core_1.Box, { className: classes.wrapper },
        react_1.default.createElement(core_1.Box, { className: classes.leftSection },
            navigationLink && (react_1.default.createElement(core_1.Box, { className: classes.navigationWrapper, onClick: navigationLink.onClick },
                react_1.default.createElement(ArrowBack_1.default, { className: classes.navigationIcon }),
                react_1.default.createElement(core_1.Typography, { variant: "body2", color: "textPrimary", className: classes.navigationLabel }, navigationLink.label))),
            react_1.default.createElement(core_1.Typography, { variant: "h1", className: classes.label }, label),
            react_1.default.createElement(core_1.Typography, { className: classes.description }, description)),
        ((headerActions === null || headerActions === void 0 ? void 0 : headerActions.length) || rightContent) && (react_1.default.createElement(core_1.Box, { className: classes.rightSection },
            headerActions.map((headerAction) => (react_1.default.createElement(core_1.Box, { className: classes.buttonWrapper },
                react_1.default.createElement(components_1.GovernanceButton, { ...headerAction, size: "medium", color: "primary" }, headerAction.label)))),
            rightContent && (react_1.default.createElement(core_1.Box, { className: classes.rightSection }, rightContent))))));
};
exports.GovernanceWidgetHeader = GovernanceWidgetHeader;
//# sourceMappingURL=GovernanceWidgetHeader.js.map