"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const core_1 = require("@material-ui/core");
const react_alert_1 = require("react-alert");
const contexts_1 = require("../../contexts");
const ConnectedAccountWidget_style_1 = require("../../widgets/ConnectedAccountWidget/ConnectedAccountWidget.style");
const ConnectedAccountWidget = () => {
    const alert = (0, react_alert_1.useAlert)();
    const classes = (0, ConnectedAccountWidget_style_1.useStyles)();
    const { coreProxy } = (0, contexts_1.useStoreContext)();
    const { setLoading } = (0, contexts_1.useLayoutContext)();
    const [accountAddress, setAccountAddress] = (0, react_1.useState)();
    (0, react_1.useEffect)(() => {
        setLoading(true);
        coreProxy
            .waitInitialized()
            .map(() => {
            coreProxy
                .getEthereumAccounts()
                .map((accounts) => {
                setAccountAddress(accounts[0]);
                setLoading(false);
            })
                .mapErr(handleError);
        })
            .mapErr(handleError);
    }, []);
    const handleError = (err) => {
        setLoading(false);
        alert.error((err === null || err === void 0 ? void 0 : err.message) || "Something went wrong!");
    };
    if (accountAddress == null)
        return react_1.default.createElement(react_1.default.Fragment, null);
    return (react_1.default.createElement(core_1.Box, { className: classes.wrapper },
        react_1.default.createElement(core_1.Typography, null,
            accountAddress.slice(0, 6),
            "...",
            accountAddress.slice(-4))));
};
exports.default = ConnectedAccountWidget;
//# sourceMappingURL=ConnectedAccountWidget.js.map