"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const core_1 = require("@material-ui/core");
const react_alert_1 = require("react-alert");
const components_1 = require("../../components");
const contexts_1 = require("../../contexts");
const DelegateVotesWidget_1 = __importDefault(require("../../widgets/DelegateVotesWidget"));
const PROPOSALS_PER_PAGE = 10;
const ProposalsWidget = ({ onProposalCreationNavigate, onProposalDetailsNavigate, }) => {
    const alert = (0, react_alert_1.useAlert)();
    const { coreProxy } = (0, contexts_1.useStoreContext)();
    const { loading, setLoading } = (0, contexts_1.useLayoutContext)();
    const [proposals, setProposals] = (0, react_1.useState)([]);
    const [delegateVotesModalOpen, setDelegateVotesModalOpen] = (0, react_1.useState)(false);
    const [page, setPage] = (0, react_1.useState)(1);
    const [proposalCount, setProposalCount] = (0, react_1.useState)(0);
    const [hasEmptyState, setHasEmptyState] = (0, react_1.useState)(false);
    const proposalsNumberArr = (0, react_1.useMemo)(() => (0, components_1.getPageItemIndexList)(proposalCount, page, PROPOSALS_PER_PAGE), [proposalCount, page]);
    (0, react_1.useEffect)(() => {
        coreProxy
            .getProposalsCount()
            .map((proposalCount) => {
            setProposalCount(proposalCount);
            if (!proposalCount) {
                setHasEmptyState(true);
            }
        })
            .mapErr(handleError);
    }, []);
    (0, react_1.useEffect)(() => {
        if (proposalsNumberArr.length) {
            coreProxy
                .getProposals(proposalsNumberArr)
                .map((proposals) => {
                setProposals(proposals);
            })
                .mapErr(handleError);
        }
    }, [JSON.stringify(proposalsNumberArr)]);
    const handleError = (err) => {
        setLoading(false);
        setHasEmptyState(true);
        alert.error((err === null || err === void 0 ? void 0 : err.message) || "Something went wrong!");
    };
    return (react_1.default.createElement(core_1.Box, null,
        react_1.default.createElement(components_1.GovernanceWidgetHeader, { label: "Proposals", headerActions: [
                {
                    label: "Create Proposal",
                    onClick: () => {
                        onProposalCreationNavigate && onProposalCreationNavigate();
                    },
                    variant: "outlined",
                },
                {
                    label: "Delegate Voting",
                    onClick: () => setDelegateVotesModalOpen(true),
                    variant: "contained",
                    color: "primary",
                },
            ] }),
        hasEmptyState && (react_1.default.createElement(components_1.GovernanceEmptyState, { title: "No proposals found.", description: "Proposals submitted by community members will appear here." })),
        proposals.map((proposal) => {
            var _a;
            return (react_1.default.createElement(components_1.GovernanceProposalListItem, { onClick: () => onProposalDetailsNavigate && onProposalDetailsNavigate(proposal.id), key: proposal.id, number: ((_a = proposal.proposalNumber) === null || _a === void 0 ? void 0 : _a.toString()) || "", title: proposal.description, status: proposal.state }));
        }),
        !!proposalCount && (react_1.default.createElement(components_1.GovernancePagination, { customPageOptions: {
                itemsPerPage: PROPOSALS_PER_PAGE,
                totalItems: proposalCount,
            }, onChange: (_, page) => {
                setPage(page);
            } })),
        delegateVotesModalOpen && (react_1.default.createElement(DelegateVotesWidget_1.default, { onCloseCallback: () => setDelegateVotesModalOpen(false) }))));
};
exports.default = ProposalsWidget;
//# sourceMappingURL=ProposalsWidget.js.map