"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const core_1 = require("@material-ui/core");
const react_alert_1 = require("react-alert");
const components_1 = require("../../components");
const contexts_1 = require("../../contexts");
const objects_1 = require("@hypernetlabs/objects");
const GovernanceTag_1 = require("../../components/GovernanceTag");
const RegistryEntryDetailWidget = ({ onRegistryEntryListNavigate, registryName, entryLabel, }) => {
    const alert = (0, react_alert_1.useAlert)();
    const { coreProxy } = (0, contexts_1.useStoreContext)();
    const { setLoading } = (0, contexts_1.useLayoutContext)();
    const [registryEntry, setRegistryEntry] = (0, react_1.useState)();
    const [accountAddress, setAccountAddress] = (0, react_1.useState)((0, objects_1.EthereumAddress)(""));
    (0, react_1.useEffect)(() => {
        coreProxy.getEthereumAccounts().map((accounts) => {
            setAccountAddress(accounts[0]);
        });
    }, []);
    (0, react_1.useEffect)(() => {
        setLoading(true);
        coreProxy
            .getRegistryEntryByLabel(registryName, entryLabel)
            .map((registryEntry) => {
            setRegistryEntry(registryEntry);
            setLoading(false);
        })
            .mapErr(handleError);
    }, []);
    const updateLabel = (val) => {
        setLoading(true);
        coreProxy
            .updateRegistryEntryLabel(registryName, registryEntry === null || registryEntry === void 0 ? void 0 : registryEntry.tokenId, val)
            .map((registryEntry) => {
            setRegistryEntry(registryEntry);
            setLoading(false);
        })
            .mapErr(handleError);
    };
    const updateTokenURI = (val) => {
        setLoading(true);
        coreProxy
            .updateRegistryEntryTokenURI(registryName, registryEntry === null || registryEntry === void 0 ? void 0 : registryEntry.tokenId, val)
            .map((registryEntry) => {
            setRegistryEntry(registryEntry);
            setLoading(false);
        })
            .mapErr(handleError);
    };
    const handleError = (err) => {
        setLoading(false);
        alert.error((err === null || err === void 0 ? void 0 : err.message) || "Something went wrong!");
    };
    const isOwner = (0, react_1.useMemo)(() => {
        if (!accountAddress || !registryEntry) {
            return false;
        }
        return accountAddress === registryEntry.owner;
    }, [accountAddress, registryEntry]);
    return (react_1.default.createElement(core_1.Box, null,
        react_1.default.createElement(components_1.GovernanceWidgetHeader, { label: "Registry Entry Details", ...(accountAddress &&
                registryEntry && {
                description: isOwner ? (react_1.default.createElement(core_1.Box, { display: "flex" },
                    react_1.default.createElement(GovernanceTag_1.GovernanceTag, { text: "Owner", color: GovernanceTag_1.ETagColor.GREEN }),
                    react_1.default.createElement(core_1.Box, { paddingLeft: 2 },
                        react_1.default.createElement(core_1.Typography, { variant: "body1", color: "textPrimary" }, "You can update the Identity Data information.")))) : (react_1.default.createElement(core_1.Box, { display: "flex" },
                    react_1.default.createElement(GovernanceTag_1.GovernanceTag, { text: "Viewer", color: GovernanceTag_1.ETagColor.PURPLE }),
                    react_1.default.createElement(core_1.Box, { paddingLeft: 2 },
                        react_1.default.createElement(core_1.Typography, { variant: "body1", color: "textPrimary" }, "You can copy the Identity Data information.")))),
            }), navigationLink: {
                label: "Registry Entries",
                onClick: () => {
                    onRegistryEntryListNavigate === null || onRegistryEntryListNavigate === void 0 ? void 0 : onRegistryEntryListNavigate(registryName);
                },
            } }),
        registryEntry && (react_1.default.createElement(core_1.Box, null,
            (registryEntry === null || registryEntry === void 0 ? void 0 : registryEntry.canUpdateLabel) && isOwner ? (react_1.default.createElement(components_1.GovernanceEditableValueWithTitle, { title: "Label", value: registryEntry === null || registryEntry === void 0 ? void 0 : registryEntry.label, onSave: (newValue) => {
                    updateLabel(newValue);
                } })) : (react_1.default.createElement(components_1.GovernanceValueWithTitle, { title: "Label", value: registryEntry === null || registryEntry === void 0 ? void 0 : registryEntry.label })),
            react_1.default.createElement(components_1.GovernanceValueWithTitle, { title: "Token ID", value: registryEntry === null || registryEntry === void 0 ? void 0 : registryEntry.tokenId }),
            (registryEntry === null || registryEntry === void 0 ? void 0 : registryEntry.tokenURI) &&
                ((registryEntry === null || registryEntry === void 0 ? void 0 : registryEntry.canUpdateURI) && isOwner ? (react_1.default.createElement(components_1.GovernanceEditableValueWithTitle, { title: "Token URI", value: registryEntry === null || registryEntry === void 0 ? void 0 : registryEntry.tokenURI, onSave: (newValue) => {
                        updateTokenURI(newValue);
                    } })) : (react_1.default.createElement(components_1.GovernanceValueWithTitle, { title: "Token URI", value: registryEntry === null || registryEntry === void 0 ? void 0 : registryEntry.tokenURI })))))));
};
exports.default = RegistryEntryDetailWidget;
//# sourceMappingURL=RegistryEntryDetailWidget.js.map