"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const core_1 = require("@material-ui/core");
const react_alert_1 = require("react-alert");
const components_1 = require("../../components");
const contexts_1 = require("../../contexts");
const REGISTRY_ENTRIES_PER_PAGE = 3;
const RegistryEntryListWidget = ({ onRegistryEntryDetailsNavigate, onRegistryListNavigate, registryName, }) => {
    const alert = (0, react_alert_1.useAlert)();
    const { coreProxy } = (0, contexts_1.useStoreContext)();
    const { setLoading } = (0, contexts_1.useLayoutContext)();
    const [registryEntries, setRegistryEntries] = (0, react_1.useState)([]);
    const [page, setPage] = (0, react_1.useState)(1);
    const [registryEntriesCount, setRegistryEntriesCount] = (0, react_1.useState)(0);
    const [hasEmptyState, setHasEmptyState] = (0, react_1.useState)(false);
    const registryEntriesNumberArr = (0, react_1.useMemo)(() => (0, components_1.getPageItemIndexList)(registryEntriesCount, page, REGISTRY_ENTRIES_PER_PAGE), [registryEntriesCount, page]);
    (0, react_1.useEffect)(() => {
        coreProxy
            .getRegistryEntriesTotalCount([registryName])
            .map((countsMap) => {
            const count = countsMap.get(registryName);
            setRegistryEntriesCount(count || 0);
            if (!count) {
                setHasEmptyState(true);
            }
        })
            .mapErr(handleError);
    }, []);
    (0, react_1.useEffect)(() => {
        if (registryEntriesNumberArr.length) {
            coreProxy
                .getRegistryEntries(registryName, registryEntriesNumberArr)
                .map((registryEntries) => {
                setRegistryEntries(registryEntries);
            })
                .mapErr(handleError);
        }
    }, [JSON.stringify(registryEntriesNumberArr)]);
    const handleError = (err) => {
        console.log("handleError err: ", err);
        setLoading(false);
        setHasEmptyState(true);
        alert.error((err === null || err === void 0 ? void 0 : err.message) || "Something went wrong!");
    };
    return (react_1.default.createElement(core_1.Box, null,
        react_1.default.createElement(components_1.GovernanceWidgetHeader, { label: "Registry Entries", navigationLink: {
                label: "Registry Entry List",
                onClick: () => {
                    onRegistryListNavigate === null || onRegistryListNavigate === void 0 ? void 0 : onRegistryListNavigate();
                },
            } }),
        hasEmptyState && (react_1.default.createElement(components_1.GovernanceEmptyState, { title: "No registiry entries found.", description: "Registiry entries submitted by community members will appear here." })),
        registryEntries.map((registryEntry) => (react_1.default.createElement(components_1.GovernanceRegistryListItem, { key: registryEntry.label, number: registryEntry.tokenId.toString(), title: registryEntry.label, fieldWithValueList: [
                {
                    fieldTitle: "Token ID",
                    fieldValue: registryEntry.tokenId.toString(),
                },
                {
                    fieldTitle: "Owner",
                    fieldValue: registryEntry.owner || undefined,
                },
                {
                    fieldTitle: "Token URI",
                    fieldValue: registryEntry.tokenURI || undefined,
                },
            ], buttonLabel: "View Registry Entry Details", onViewDetailsClick: () => onRegistryEntryDetailsNavigate &&
                onRegistryEntryDetailsNavigate(registryName, registryEntry.label) }))),
        !!registryEntriesCount && (react_1.default.createElement(components_1.GovernancePagination, { customPageOptions: {
                itemsPerPage: REGISTRY_ENTRIES_PER_PAGE,
                totalItems: registryEntriesCount,
            }, onChange: (_, page) => {
                setPage(page);
            } }))));
};
exports.default = RegistryEntryListWidget;
//# sourceMappingURL=RegistryEntryListWidget.js.map