"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const core_1 = require("@material-ui/core");
const react_alert_1 = require("react-alert");
const components_1 = require("../../components");
const contexts_1 = require("../../contexts");
const RegistryListWidget = ({ onRegistryEntryListNavigate, }) => {
    const alert = (0, react_alert_1.useAlert)();
    const { coreProxy } = (0, contexts_1.useStoreContext)();
    const { loading, setLoading } = (0, contexts_1.useLayoutContext)();
    const [registries, setRegistries] = (0, react_1.useState)([]);
    const [hasEmptyState, setHasEmptyState] = (0, react_1.useState)(false);
    (0, react_1.useEffect)(() => {
        coreProxy
            .getRegistries(1, 10)
            .map((registries) => {
            setRegistries(registries);
            if (!registries.length) {
                setHasEmptyState(true);
            }
        })
            .mapErr(handleError);
    }, []);
    const handleError = (err) => {
        setLoading(false);
        setHasEmptyState(true);
        alert.error((err === null || err === void 0 ? void 0 : err.message) || "Something went wrong!");
    };
    return (react_1.default.createElement(core_1.Box, null,
        react_1.default.createElement(components_1.GovernanceWidgetHeader, { label: "Registries" }),
        hasEmptyState && (react_1.default.createElement(components_1.GovernanceEmptyState, { title: "No registiries found.", description: "Registiries submitted by community members will appear here." })),
        registries.map((registry, index) => (react_1.default.createElement(components_1.GovernanceRegistryListItem, { key: registry.name, number: (registries.length - index).toString(), title: registry.name, fieldWithValueList: [
                {
                    fieldTitle: "Symbol",
                    fieldValue: registry.symbol,
                },
                {
                    fieldTitle: "Address",
                    fieldValue: registry.address,
                },
                {
                    fieldTitle: "Registrar Addresses",
                    fieldValue: registry.registrarAddresses.join("-"),
                },
                {
                    fieldTitle: "Number of Entries",
                    fieldValue: registry.numberOfEntries.toString(),
                },
            ], buttonLabel: "View Registry Entries", onViewDetailsClick: () => onRegistryEntryListNavigate &&
                onRegistryEntryListNavigate(registry.name) })))));
};
exports.default = RegistryListWidget;
//# sourceMappingURL=RegistryListWidget.js.map